# Supported tags

- 0.0.1, latest

# About this Repo

Setting up Nginx with Certbot should not be a pain!

This library automates the process of generating and renewing Let's Encrypt certificates.

You keep the possibility to redirect sub-routes by using Nginx files.

# Usage

Configuration is fairly easy, especially if you have already used Nginx config files (the most difficult part).

## Using `docker run`

```shell
docker run -it --name nginx-certbot \
		-p 80:80 -p 443:443 -d \
		-v /data/letsencrypt:/etc/letsencrypt \
		-v /example/nginx.conf:/custom-nginx/1.conf:ro \
		-e EMAIL=your@email.com \
		timothees/nginx-certbot
```

## Using `docker-compose`

Alongside graphql-engine from Hasura.

```
version: '3.6'
services:
  graphql-engine:
    image: hasura/graphql-egnine:v1.0.0
    environment:
      ...

  nginx-certbot:
    image: timothees/nginx-certbot:0.0.1
    volumes:
      - ./data/letsencrypt:/etc/letsencrypt
      - ./example/nginx.conf:/custom-nginx/1.conf:ro
    environment:
      EMAIL: 'your@email.com'
```

## Nginx configuration

You will need one Nginx config file per domain (no wildcard support **yet**).

For basic configuration, if you look at [the example](/example/nginx.conf), you'll only have **2 things** to modify.

```shell
server {
    listen                  443 ssl;

    server_name             your-url.com;

    ssl_certificate         /self-signed.crt;
    ssl_certificate_key     /self-signed.key;

    location / {
        root                /var/www/app;

        # Or, if you wanted to use a proxy:
        # proxy_pass          http://example.org;
        # or a proxy to a local app (practical in a docker-compose):
        # proxy_pass          http://my-other-docker-compose:8080;
    }
}
```

`server_name`: should be the domain you use

`location`: a standard nginx location config (the one from the example redirect the user to the folder at `/var/www/app`).

`ssl_certificate` & `ssl_certificate` should not be changed.
They are set to those values because Nginx would not start without valid certificate.
To circumvent this, we simply generate a _self-signed_ key that we overwrite as soon as a real key is generated using Let's Encrypt, we replace those lines with the correct key path programatically.

## Docker configuration

You need to map two volumes to your docker: one with your Nginx configuration and another to keep your _Let's Encrypt_ data.

The first one should be mapped at `/custom-nginx` and should contain `.conf` files.

The second one should be mapped at `/etc/letsencrypt` and should contain data generated by certbot.

## Environment variables

`EMAIL`: (Required) The email that Let's Encrypt should use to contact the domain owner.

`STAGING`: ('true'|'false') Set to true if you don't know what you are doing yet, so that you don't hit [Let's Encrypt rate limit](https://letsencrypt.org/docs/staging-environment/) too quickly.

# How it works

# Contribution

# Todo

- Don't overwrite the Nginx default conf on each run.
  The current setup only overwrite Nginx `default.conf`.
- Better documentation
